<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>ICS File Reader</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/ical.js/1.4.0/ical.min.js"></script>
    <style>
        #drop_zone {
            border: 2px dashed #0087F7;
            border-radius: 5px;
            background: #F3F4F6;
            padding: 20px;
            text-align: center;
            color: #4B5563;
            margin-bottom: 20px;
            cursor: pointer;
        }

        table {
            width: 100%;
            border-collapse: collapse;
        }

        table, th, td {
            border: 1px solid black;
        }

        th, td {
            padding: 10px;
            text-align: left;
        }

        #file_input {
            display: none; /* Hide the file input */
        }
    </style>
</head>
<body>

<div id="drop_zone">Drag and drop an ICS file here or click to select</div>
<input type="file" id="file_input" accept=".ics">
<form onsubmit="submitForm(event);return false;">
    <table id="events_table">
        <thead>
        <tr>
            <th>Select</th>
            <th>Event</th>
            <th>Start Date</th>
            <th>End Date</th>
        </tr>
        </thead>
        <tbody>
        <!-- Rows will be added here dynamically -->
        </tbody>
    </table>
    <input type="submit" value="Ausgewählte importieren">
</form>
<script>
    var parsedEvents = []

    function getIcalEventById(uid) {
        const event = parsedEvents.find(e => e.uid === uid);
        return event;
    }

    function submitForm(evt) {
        evt.preventDefault();
        let selectedEvents = [];

        // Loop over all checkboxes to find the checked ones
        document.querySelectorAll('#events_table input[type="checkbox"]:checked').forEach(checkbox => {
            const uid = checkbox.value;
            const event = {
                event_id: "",
                resourceId: "",
                textColor: "",
                color: "",
                attachedResources: [],
                starttime: checkbox.dataset.starttime,
                endtime: checkbox.dataset.endtime,
                title: checkbox.dataset.summary, // Example: Get title from a data attribute
                savekind: "create",
                extended_props: {},
                allDay: true, // Or determine based on the event data
                attachedContacts: [],
                data_owners: [],
                reminders: [],
                tags: [],
                data: {
                    event_status: "confirmed",
                    appointment_type: ["termin"]
                }
            };
            selectedEvents.push(event);
        });

        console.log("CREATED EVENTS", selectedEvents);
    }

    function handleFile(file) {
        if (file.type === "text/calendar") {
            var reader = new FileReader();
            reader.onload = function (e) {
                let intl_options = {
                    year: 'numeric',
                    month: '2-digit',
                    day: '2-digit',
                    hour: '2-digit',
                    minute: '2-digit'
                };
                var jcalData = ICAL.parse(e.target.result);
                var comp = new ICAL.Component(jcalData);
                var events = comp.getAllSubcomponents("vevent");
                var tableBody = document.getElementById('events_table').getElementsByTagName('tbody')[0];
                tableBody.innerHTML = ""; // Clear existing rows

                events.forEach(function (event) {
                    var vevent = new ICAL.Event(event);
                    parsedEvents.push(vevent)
                    var row = tableBody.insertRow();
                    var cell1 = row.insertCell();
                    var cell2 = row.insertCell();
                    var cell3 = row.insertCell();
                    var cell4 = row.insertCell();

                    var checkbox = document.createElement('input');
                    checkbox.type = "checkbox";
                    checkbox.id = vevent.uid
                    checkbox.value = vevent.uid
                    checkbox.dataset.starttime = vevent.startDate.toJSDate()
                    checkbox.dataset.endtime = vevent.endDate.toJSDate()
                    checkbox.dataset.summary = vevent.summary
                    cell1.appendChild(checkbox);

                    cell2.textContent = vevent.summary;

                    // Format start and end dates
                    var startDateFormatted = new Intl.DateTimeFormat(navigator.language, intl_options).format(vevent.startDate.toJSDate());
                    var endDateFormatted = new Intl.DateTimeFormat(navigator.language, intl_options).format(vevent.endDate.toJSDate());

                    cell3.textContent = startDateFormatted;
                    cell4.textContent = endDateFormatted;
                });
            };
            reader.readAsText(file);
        } else {
            alert("Please select an ICS file.");
        }
    }

    document.getElementById('drop_zone').addEventListener('drop', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var file = e.dataTransfer.files[0]; // Assuming single file drop
        handleFile(file);
    }, false);

    document.getElementById('drop_zone').addEventListener('dragover', function (e) {
        e.preventDefault();
        e.stopPropagation();
    }, false);

    document.getElementById('drop_zone').addEventListener('click', function () {
        document.getElementById('file_input').click();
    }, false);

    document.getElementById('file_input').addEventListener('change', function (e) {
        var file = e.target.files[0];
        if (file) {
            handleFile(file);
        }
    }, false);
</script>

</body>
</html>
